;
; FIRE  by Daniel A. Nagy for ZX-Uno (August 2018)
;

; Compile: sjasmplus fire.asm


	org $8000

start:  ld hl,pal
	xor a
	out ($FE),a
	ld c,$3B
setupl: ld b,$BF
	out (c),a
	ld b,$FF
	ld d,(hl)
	inc hl
	out (c),d
	inc a
	cp 16
	jr c,setupl
	ld b,$FC
	ld a,64
	out (c),a
	inc b
	ld a,3
	out (c),a
	dec b
	ld a,11
	out (c),a
	inc b
	in a,(c)
	or $C0
	out (c),a
	ld hl,rnd
initr:  ld (hl),l
	inc l
	jr nz,initr

burn:   ld de,heat+128*76
	ld h,rnd/$100
burnl:  ld l,e
	inc l
	ld a,(rc4j)
	ld b,(hl)
	add a,b
	ld (rc4j),a
	ld l,a
	ld c,(hl)
	ld (hl),b
	ld l,e
	inc l
	ld (hl),c
	ld a,b
	add c
	and $7F
	ld (de),a
	inc e
	jr nz,burnl

	ld de,$4600
	ld hl,heat+127
	ld bc,19
fli:    ld a,(hl)
	inc hl
	add a,(hl)
	inc l
	add a,(hl)
	dec l
	ex af,af'
	ld a,l
	add a,128
	jr nc,noc1
	inc h
noc1:   ld l,a
	ex af,af'
	add a,(hl)
	rra
	srl a
	sbc a,0
	adc a,0
	dec h
	ld (hl),a
	srl a
	srl a
	ld (de),a
	ld a,l
	add a,128
	jr nc,noc2
	inc h
noc2:   ld l,a
	ld a,(hl)
	inc hl
	add a,(hl)
	inc l
	add a,(hl)
	dec l
	ex af,af'
	ld a,l
	add a,128
	jr nc,noc3
	inc h
noc3:  ld l,a
	ex af,af'
	add a,(hl)
	rra
	srl a
	sbc a,0
	adc a,0
	dec h
	ld (hl),a
	srl a
	srl a
	ex de,hl
	rld
	ex de,hl
	ld a,l
	add a,128
	jr nc,noc4
	inc h
noc4:   ld l,a
	inc e
	djnz fli
	inc d
	dec c
	jr nz,fli
	in a,($FE)
	or $E0
	inc a
	jp z,burn
	ld bc,$FC3B
	ld a,64
	out (c),a
	inc b
	xor a
	out (c),a
	ret

pal:    defb $00, $04, $08, $0C, $10, $14, $38, $5C
        defb $7C, $9C, $BC, $DC, $FC, $FD, $FE, $FF
rc4j:   defb 0

; Align to 256-byte page boundary

rnd:    equ (($ + $FF) / $100) * $100
heat:   equ rnd + $100 



        DEVICE ZXSPECTRUM128
	SAVETAP "fire.tap",start